
require 'redmine'

module WikiContactsContactList  
  Redmine::WikiFormatting::Macros.register do
    
    desc "make a contact list of redmine users."
    macro :contact_matrix do |obj, args|      
      args, options = extract_macro_options(args, :order_by, :filter_by)
      disp = String.new 
      
      actions = ["Anonymous", "Admin"]  # Used to filter out these 2 users
      if(options[:order_by].present?)  
        if(options[:filter_by].present?)
          users = User.joins(custom_values: :custom_field).where(custom_fields: {name: options[:filter_by]}).where(custom_values: {value: "1"}).order(options[:order_by])
        else
          users = User.order(options[:order_by]).where('lastname not in (?)', actions)
        end
      else  
        if(options[:filter_by].present?)
          users = User.joins(custom_values: :custom_field).where(custom_fields: {name: options[:filter_by]}).where(custom_values: {value: "1"})
        else      
          users = User.where('lastname not in (?)', actions)
        end
      end
      
      if users.present?
      
        disp << "<table>"
        
        disp << "<thead>"
        disp << "<tr>"
        User.attribute_names.each do |attr|
          if args.include?(attr)
            disp << "<td>"
            disp << h(attr)
            disp << "</td>"
          end
        end
        
        users[0].visible_custom_field_values.each do |cfv|
          if args.include?(cfv.custom_field.name)
            disp << "<td>"
            disp << h(cfv.custom_field.name)
            disp << "</td>"
          end
        end
        
        disp << "</tr>"
        disp << "</thead>"
        
        disp << "<tbody>"
        
        
        users.each do |user|
           disp << "<tr>"
           
           user.attributes.each do |attr_name, attr_value|
             if args.include?(attr_name)
               disp << "<td>"
               disp << h(attr_value)
               disp << "</td>"
             end
           end
           
           user.visible_custom_field_values.each do |cfv|
             if args.include?(cfv.custom_field.name)
               disp << "<td>"
               if cfv.custom_field.field_format == "bool"
                 if cfv.value == "1"
                   disp << "&#10004;"
                 else
                   disp << " "
                 end
               else
                 disp << h(cfv.value)
               end
               
               disp << "</td>"
             end
           end
           
           disp << "</tr>"
        end
        disp << "</tbody>"
        disp << "</table>"
      
      else
        disp << "No Users Found"
      end


      return disp.html_safe
    end
    
  end
end

